# Class Pipe

java.lang.Object
java.nio.channels.Pipe

public abstract class Pipe extends Object
A pair of channels that implements a unidirectional pipe.

A pipe consists of a pair of channels: A writable `sink` channel and a readable `source` channel. Once some bytes are written to the sink channel they can be read from the source channel in exactly the order in which they were written.

Whether or not a thread writing bytes to a pipe will block until another thread reads those bytes, or some previously-written bytes, from the pipe is system-dependent and therefore unspecified. Many pipe implementations will buffer up to a certain number of bytes between the sink and source channels, but such buffering should not be assumed.

Since:
  1.4

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `Pipe.SinkChannel`
  A channel representing the writable end of a `Pipe`.
  `static class`
  `Pipe.SourceChannel`
  A channel representing the readable end of a `Pipe`.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `Pipe()`
  Initializes a new instance of this class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Pipe`
  `open()`
  Opens a pipe.
  `abstract Pipe.SinkChannel`
  `sink()`
  Returns this pipe's sink channel.
  `abstract Pipe.SourceChannel`
  `source()`
  Returns this pipe's source channel.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### Pipe

    protected Pipe()
    Initializes a new instance of this class.

- ## Method Details

  - ### source

    public abstract Pipe.SourceChannel source()
    Returns this pipe's source channel.
    Returns:
      This pipe's source channel

  - ### sink

    public abstract Pipe.SinkChannel sink()
    Returns this pipe's sink channel.
    Returns:
      This pipe's sink channel

  - ### open

    public static Pipe open() throws IOException
    Opens a pipe.

    The new pipe is created by invoking the `openPipe` method of the system-wide default `SelectorProvider` object.

    Returns:
      A new pipe
    Throws:
      `IOException` - If an I/O error occurs